---
layout: handbook-page-toc
title: "GitLab Dedicated Group"
---

![GitLab Dedicated Group logo](img/dedicated_team_logo.png)

## On this page
{:.no_toc .hidden-md .hidden-lg}

- TOC
{:toc .hidden-md .hidden-lg}

# Team

## Mission

The GitLab Dedicated team is mission is to create a fully managed, single-tenant GitLab environment, served through a GitLab Dedicated platform. It is developed to remove any manual interactions with customer tenant installations, and to ensure that the customer tenants are fully focused on unlocking the power of The One DevOps Platform.

## Vision

The GitLab Dedicated team is a customer facing team, with team members focused on a high level of infrastructure automation, and enabling customer interactions with the GitLab Dedicated platform.

Team mission is to:

* Develop a 100% automated system for provisioning a large number of single tenant GitLab sites
* Automate maintenance tasks without human interaction for the said sites
* Create and manage central observability stack, as well as observability stack per customer tenant
* Create customer portal (Switchboard), exposing administrative operations to customer tenants

## Performance Indicators

Team performance indicators are not fully defined. We are going to consider a **Provisioning SLO** to start with, possibly followed by [DORA 4 metrics](https://cloud.google.com/blog/products/devops-sre/using-the-four-keys-to-measure-your-devops-performance).

## Team Members


Engineering team members of GitLab Dedicated are publicly referenced with specialty for `Environment Automation`, due to team being formed while the product was not public.

<%= direct_team(manager_slug: 'o-lluch')%>

## Working with us

To engage with the GitLab Dedicated team:

* [Create an issue](https://gitlab.com/gitlab-com/gl-infra/gitlab-dedicated/team/-/issues/new) in the GitLab Dedicated team issue tracker (**Note** The issue tracker will be made public after [work in epic 33 "Considerations for making Dedicated projects public"](https://gitlab.com/groups/gitlab-com/gl-infra/gitlab-dedicated/-/epics/33) is completed)
  * For feature requests, use the [feature_requests issue template](https://gitlab.com/gitlab-com/gl-infra/gitlab-dedicated/team/-/blob/main/.gitlab/issue_templates/feature_request.md) and fill in the required information
* When creating an issue, it is not necessary to `@`mention anyone
* In case you want to mention the whole team, use `@gitlab-dedicated` handle on GitLab.com
* Slack channels
  * For GitLab Dedicated specific questions, you can find us in [#f_gitlab_private](https://gitlab.slack.com/archives/C01S0QNSYJ2)
  * Engineering team has its [own separate channel](https://gitlab.slack.com/archives/C025LECQY0M) for team related discussions

## How we work

### Meetings and Scheduled Calls

Our preference is to work asynchronously, within our project issue tracker as described in [the project management section](#project-management).

The team does have a set of regular synchronous calls:

* `Demo call` - This call is on the agenda once per week. During this call, team members show off their progress, and engage with other team members on topics related to GitLab Dedicated platform. Demo calls are supposed to be rough around the edges and unpolished. In fact, if the demo looks polished, we will discuss whether we are being ambitious enough with our goals
* `Team call` - During this call, we are sharing important information for team-members day-to-day, as well as project items requiring a sync discussion
* 1-1s between the Individual Contributors and Engineering Manager



Impromptu Zoom meetings for discussing GitLab Dedicated work between individuals are created as needed.
It is expected that these meetings are private streamed, or recorded(1*), and then uploaded to [GitLab Unfiltered playlist](https://www.youtube.com/playlist?list=PL05JrBw4t0KqC5FfUVPyndvLvTWifWbfB).
The outcome of the call is shared in a persistent location (Slack is not persistent). This is especially important as the team grows, because any decisions that are made in the early stage have will be questioned in the later stages when the team is larger.

`1*` Exceptions to the recording rule are: 1-1 calls, discussions around non-project work, and in cases where parties do not feel comfortable with recording. However, even with the exceptions, outcome of project related discussions need to be logged in a persistent location, such as the main issue tracker.

### Project Management

We use Epics, Issues, and Issue Boards to organize our work, as they complement each other.

The single source of truth for _all_ GitLab Dedicated work across different functions is [GitLab Dedicated epic](https://gitlab.com/groups/gitlab-com/gl-infra/-/epics/479).

The single source of truth for engineering work required for GitLab Dedicated is [GitLab Dedicated Implementation Epic](https://gitlab.com/groups/gitlab-com/gl-infra/-/epics/481). This is considered to be a top-level epic for all of the implementation work, and will be referenced as such.

Epics that are added as children to the top-level epic are used to describe projects that the team undertakes.

Having all projects at this level allows us to use a single list for prioritization and enables us to prioritize
work for different services alongside each other. Projects are prioritized in line with [the Roadmap](https://gitlab.com/gitlab-com/gl-infra/gitlab-dedicated/team/-/blob/main/Roadmap.md) and the needs of each individual milestone defined in the Implementation Plan.

Project status is maintained in the description of the top-level epic so that it is visible at a glance. This is auto-generated using [the epic issues summary project](https://gitlab.com/gitlab-com/gl-infra/epic-issue-summaries).

Example organization for engineering work is shown on the diagram below:

```mermaid
graph TD
A(GitLab Dedicated) --> C[Implementation Plan]
C --> D([Alpha])
C --> E([Beta])
C --> F([Limited Availability])
C --> G([General Availability])


%% Alpha
D --> I[Phase1]
D --> M[Phase2]

I --> J[Provision using GET]
I --> K[Provision Observability stack]
I --> L[Provision accounts]



click A "https://gitlab.com/groups/gitlab-com/gl-infra/-/epics/479"
click C "https://gitlab.com/groups/gitlab-com/gl-infra/-/epics/481"
click D "https://gitlab.com/groups/gitlab-com/gl-infra/-/epics/483"
click E "https://gitlab.com/groups/gitlab-com/gl-infra/-/epics/495"
click F "https://gitlab.com/groups/gitlab-com/gl-infra/-/epics/484"
click G "https://gitlab.com/groups/gitlab-com/gl-infra/-/epics/485"
```

_Note_ If you are not seeing the diagram, make sure that you have accepted all cookies.

#### Project Ownership

Each project has an owner who is responsible for delivering the project.

The owner needs to:

1. Update the status block in the epic description each week.
1. Work with others to move project issues through the boards.

#### Project Structure

The epic for the project must have the following items:

1. **Background**, including a problem statement, to provide context for people looking to understand the project.
1. **Exit criteria** for the specific goals of the project.
    1. These are created as issues with the `exit criterion` label in the epic and are linked in the description.
    1. We create these at the start of the project to allow us to keep focused on our goal, and use [blocking issues](https://docs.gitlab.com/ee/user/project/issues/related_issues.html) to indicate the state of each exit criterion.
1. **Status yyyy-mm-dd** should be the final heading in the description.
    1. This enables others who are interested in the epic to see the latest status without having to read through all comments or issues attached to the epic.
    1. This heading is used to auto-generate the status information on the top-level epic.
1. **Start date** is set to the expected start date, and updated to be the actual start date when the project begins.
1. **Due date** is set to be the expected end date.
    1. This should be seen as a target, and this target is re-evaluated every few weeks while the project is in progress. The date that a project actually ended is taken from the date that the epic was closed.

### Issue boards

Issue boards, such as [Beta Development board](https://gitlab.com/groups/gitlab-com/gl-infra/gitlab-dedicated/-/boards/2874746?label_name[]=Launch%3A%3ABeta) track the progress of all ongoing work.

On this single board, the goal is to get issues from `workflow-infra::Triage` into the `workflow-infra::Done` state, within a product [launch milestone](#launch-milestone-labels). Each of the workflow labels have a special meaning described in [the workflow labels](#workflow-labels) section.

### Merge Requests

GitLab Dedicated team respects the Company principle of [everything starting with a merge request](https://about.gitlab.com/handbook/communication/#everything-starts-with-a-merge-request).

1. All Merge Requests (MRs) must go through the review process.
1. It is expected that MR author assigns reviewers once the MR is ready to go.
1. Unless otherwise explicitly noted in the MR description itself, it is expected from a first approver to also merge the MR they just approved for efficiency. Add `**This MR should be approved by all approvers, last approver should merge.**` as the first line in MR description to state the intention clearly.
1. Resolution of an open thread may be done by the author or any reviewer, based on their good-faith understanding that the comment has been adequately addressed; an approval while leaving open threads unresolved means the author or other reviewers are expected to manage those threads to completion.

The MR approval rule settings for all projects should be:

1. `Prevent approval by author` On :heavy_check_mark:
1. `Prevent approvals by users who add commits` On :heavy_check_mark:
1. `Prevent editing approval rules in merge requests` Off :x: for emergencies allowing us to act in good faith when absolutely necessary
1. `Remove all approvals when commits are added to the source branch` Off :x:

#### Priorities

We are prioritising reviewing documentation merge requests above all other ones, until further notice. Every merge request documenting acquired knowledge (or concluded discussion) has an impact beyond only the people working on the project directly. In the early stages of building the product, many stakeholders have a need to find actual information quickly, and that means that every line documented increases efficiency of people working on the project as well as people contributing to the project indirectly as we enable more direct self-service.

#### Failed pipeline on the default branch

Having a passing pipeline (green build) on the default branch is very important. Failed pipeline (red build) causes delays in all MR's in progress targeting the default branch, and more importantly, it can cause significant regressions if new MR's are merged into it.

When a red build in the default branch is detected, the first course of action is to **revert** the MR that introduced failures. Reverting should be done **even if it is more work**. A couple of answers to the question "why?":

1. Ensuring that the build is green unblocks all other work in progress.
1. Reverts are safe and quick to do in most cases, and revert leaves a trail in project history. This makes future tracking simpler.
1. When fixing the problem that caused the red build, reviewing the fix in the context of the original change is easier for any reviewer.
1. It is not uncommon for a quick-fix to introduce more issues, thus creating a chain of quick-fixes that are hard to track in the context of the original change.
1. Fixing the problem that caused the red build is less stressful when other team members are not depending on the fix being available.

#### Merge request reviewers

Assign all developers of Dedicated team to all of the MRs that are due for review. While it is OK for only two people to get the MR to the merged state (author + 1 reviewer), assigning everybody gives more exposure to the work in progress and gives a chance for more parties to provide feedback, leading to better quality overall.

#### Resolving threads on a merge-request

As the merge request author, please don’t mark discussions resolved until the reviewer has had a chance to respond. In general, if the reviewer has not yet approved the MR, and the thread is non-trivial, don’t mark their comments as resolved, let the reviewer review your response and resolve accordingly during the next round of view. If they have approved the MR, but comments remain unresolved, it's generally fine to resolve comments before merging.

#### Merge Request Review Assignees

GitLab Dedicated follows the same pattern for author/reviewer assignment as the standard GitLab practice, documented in the [Code Review Guidelines documentation](https://docs.gitlab.com/ee/development/code_review.html#dogfooding-the-reviewers-feature).

This can be summarized as follows:

> * Merge request authors and DRIs stay as Assignees
> * Authors request a review from Reviewers when they are expected to review
> * Reviewers remove themselves after they’re done reviewing/approving
> * The last approver stays as Reviewer upon merging

### Labels

Commonly used labels are:

1. The team label, `team::GitLab Dedicated`.
1. Scoped `workflow-infra` labels.
1. Scoped `component` labels.
1. Scoped `cloud-provider` labels.
1. Scoped `Launch` labels.

The `team::GitLab Dedicated` label is used in order to allow for easier filtering of issues applicable to the team that have group level labels applied.

#### Workflow labels

We leverage scoped workflow labels to track different stages of work.

In general, we want to see issues move from `workflow-infra::Triage` to `workflow-infra::Ready` stage to indicate that the submitted issue will go through for implementation. Once the issue is marked with `workflow-infra::Ready`, we are ready to work on the issue until we get the issue marked with `workflow-infra::Done`.

The standard progression of workflow is from top to bottom in the table below:

| State Label | Description |
| ----------- | ----------- |
| ![Triage](./img/label-triage.png) | Default label added to issues created. Issues with this label need to be confirmed as work we would consider. If we don't want to consider the issue further, we mark it with `workflow-infra::Cancelled` and close it. If this issue does not need Product validation, and we are ready for implementation, issue is moved to `workflow-infra::Ready`. Otherwise, we move it to the next stage `workflow-infra::Proposal`. |
| ![Proposal](./img/label-proposal.png) | In this stage, proposal is being created and put forward for review with the rest of the team. Issues in this stage are also a part of Product validation workflow. If there are no further questions or blockers, the issue can be moved into "workflow-infra::Ready". |
| ![Ready](./img/label-ready.png) | The issue is waiting to be picked up for work. |
| ![In Progress](./img/label-in_progress.png) | Issue is assigned to a DRI and work has started. |
| ![Done](./img/label-done.png) | Issue is updated with the outcome of the work that was done, and this label is applied and issue closed. |

There are three other workflow labels of importance:

| State Label | Description |
| ----------- | ----------- |
| ![Cancelled](./img/label-cancelled.png) | Work in the issue is being abandoned due to external factors or decision to not resolve the issue. After applying this label, issue will be closed. |
| ![Stalled](./img/label-stalled.png) | If no update has been provided in an issue for over a week, the issue will get this label. The team Engineering Manager is responsible for reviewing the status of the issue and helping it move along. |
| ![Blocked](./img/label-blocked.png) | Work is blocked due external dependencies or other external factors. Where possible, a [blocking issue](https://docs.gitlab.com/ee/user/project/issues/related_issues.html) should also be set. After applying this label, issue will be regularly triaged by the team until the label can be removed. |

#### Component labels

To denote different types of components and services we are working with, we leverage `component::` scoped labels. By using these labels, we are able to track the distribution of work across different components which also allows us to change focus where needed. These labels are created on [the GitLab Dedicated group level](https://gitlab.com/groups/gitlab-com/gl-infra/gitlab-dedicated), since they are focused on work required specifically for GitLab Dedicated.

**NOTE** We do not use `Service::` labels given that service labels are used by GitLab SaaS related projects.

Component labels with their description can be found [by searching prioritized labels](https://gitlab.com/gitlab-com/gl-infra/gitlab-dedicated/team/-/labels?subscribed=&search=component).

#### Launch milestone labels

In order to make GitLab Issue board easier to use, we also apply `Launch::` scoped labels, denoting the Product launch milestones defined in [the project readme](https://gitlab.com/gitlab-com/gl-infra/gitlab-dedicated/team/-/blob/main/README.md#timeline). Launch labels indicate the intended milestone during which work can be executed (intention, not guarantee).

Valid options are one of:

1. `Launch::Beta` - Beta
1. `Launch::LA` - Limited Availability
1. `Launch::GA` - General Availability

These labels exist only because filtering by epic in GitLab issue boards does not include issues from sub-epics. We have an option of creating an epic board (listing all epics), or issue board per defined epic, but there is currently no way to centralise all issues within a parent epic's children epics.

#### Cloud Provider labels

These scoped labels are intended to distinguish generic work to everything made for a specific cloud provider.

| Cloud Provider Label | Description |
| ----------- | ----------- |
| ![AWS](./img/cloud-provider-aws.png) | Amazon Cloud specific implementation |
| ![AWS](./img/cloud-provider-gcp.png) | Google Cloud specific implementation |

### Resources

Resources used by the team to conduct work are described on the [Development Resources Page](https://gitlab.com/gitlab-com/gl-infra/gitlab-dedicated/team/-/blob/main/engineering/Dev-resources.md).

## History and trivia

* Name for [`Switchboard` customer portal](https://gitlab.com/gitlab-com/gl-infra/gitlab-dedicated/team/-/issues/7#note_591358260) was suggested by @marin after he spent a day trying to figure out which mixing console (Also known as a switchboard/soundboard) to get for amateur music making. He didn't buy anything, but the suggestion was accepted.
* Name for [`Amp` management cluster](https://gitlab.com/gitlab-com/gl-infra/gitlab-dedicated/team/-/issues/31#note_609710775) was suggested by @ccasella, as it is the instance that is "powering" supply of other instances.
